//*****************************************
// AT mega328P-PA(32pin TDFP) fourteen IN-172 clock Program
// CPU Clock:8MHz
//   iq[Yf[^@WȂBIV[^(8MHz)ɂj
//
// File Name:nixie.c
//
//  2017/09/13 New TAB4 Taishi
//  2017/12/13 Ver 2.00 Taishi
//  2018/10/25 Modify for Fifteen IN-17 Clock Taishi
//  2019/12/30 Modify for fourteen IN-172 Clock Taishi
//*****************************************

#include	<avr/pgmspace.h>
#include	<avr/io.h>

#include	"fourteen_in172_clock.h"
#include	"nixie.h"

// **********************************************************
// *********************** NIXE TUBE ************************
// **********************************************************
//

// **********************************************************
//@jLV[ǂ͂O`VAlIǂ͂WFR\
//@@jLV[ǑÍ@(WjubNƉʁiVjubNʂ
//@@obO`R̃R[hɂđI
//@@@R@Q@P@O
//@@@k@k@k@k@||@O@@j
//@@@k@k@k@g@||@P@@̏㌅@@b̉
//@@@k@k@g@k@||@Q@@̉@@b̏㌅
//@@@k@k@g@g@||@R@@̏㌅@@̉
//@@@k@g@k@k@||@S@@N̍ŉʁ@̏㌅
//@@@k@g@k@g@||@T@@N̂RԖځ@̉
//@@@k@g@g@k@||@U@@N̂QԖځ@̏㌅
//@@@k@g@g@g@||@V@@N̍ŏʁ@̉
//@@@g@k@k@k@||@W@@IȂ
//@@@g@k@k@g@||@X@@IȂ
//@@@g@k@g@k@||@PO@IȂ
//@@@g@k@g@g@||@PP@IȂ
//@@@g@g@k@k@||@PQ@IȂ
//@@@g@g@k@g@||@PR@IȂ
//@@@g@g@g@k@||@PS@IȂ
//@@@g@g@g@g@||@PT@IȂ
//
//@@@ʃubNiNAAj
//@@\locSCTCUCV̂Srbĝabcōs
//@@@V@U@T@S
//@@@k@k@k@k@||@O
//@@@k@k@k@g@||@P
//@@@k@k@g@k@||@Q
//@@@k@k@g@g@||@R
//@@@k@g@k@k@||@S
//@@@k@g@k@g@||@T
//@@@k@g@g@k@||@U
//@@@k@g@g@g@||@V
//@@@g@k@k@k@||@W
//@@@g@k@k@g@||@X
//@@@g@k@g@k@||@
//@@@g@k@g@g@||@
//@@@g@g@k@k@||@
//@@@g@g@k@g@||@
//@@@g@g@g@k@||@
//@@@g@g@g@g@||@
//
//@@@ʃubNiAAbj
//@@\loaOCocPCoaPCocR̂Srbĝabcōs
//@@@ocR@oaP@ocP@oaO
//@@@k@@@k@@@k@@@k@@||@O
//@@@k@@@k@@@k@@@g@@||@P
//@@@k@@@k@@@g@@@k@@||@Q
//@@@k@@@k@@@g@@@g@@||@R
//@@@k@@@g@@@k@@@k@@||@S
//@@@k@@@g@@@k@@@g@@||@T
//@@@k@@@g@@@g@@@k@@||@U
//@@@k@@@g@@@g@@@g@@||@V
//@@@g@@@k@@@k@@@k@@||@W
//@@@g@@@k@@@k@@@g@@||@X
//@@@g@@@k@@@g@@@k@@||@
//@@@g@@@k@@@g@@@g@@||@
//@@@g@@@g@@@k@@@k@@||@
//@@@g@@@g@@@k@@@g@@||@
//@@@g@@@g@@@g@@@k@@||@
//@@@g@@@g@@@g@@@g@@||@
//
//@@j\́@ʃubN
//oc@V@U@T@S
//@@@k@k@k@k@||@j
//@@@k@k@k@g@||@j
//@@@k@k@g@k@||@Ηj
// 
//@@j\́@ʃubN
//@@@ocR@oaP@ocP@oaO
//@@@k@@@k@@@g@@@g@@||@j
//@@@k@@@g@@@k@@@k@@||@ؗj
//@@@k@@@g@@@k@@@g@@||@j
//@@@k@@@g@@@g@@@k@@||@yj
//
// **********************************************************

unsigned char	path_limit = 1;

static	unsigned char	nixie_hdata[KETA_SEL_MAX+2];		// +1 ŗǂAÔ
static	unsigned char	nixie_lpddata[KETA_SEL_MAX+2];		// +1 ŗǂAÔ
static	unsigned char	nixie_lpbdata[KETA_SEL_MAX+2];		// +1 ŗǂAÔ
static	unsigned char	nixie_select[KETA_SEL_MAX+2];		// +1 ŗǂAÔ
static	unsigned char	nixie_act_num = 0;
static	unsigned char	dynamic_nixie = 0;

#define		NIXE_HDATA_MASK		0b00001111	// PD 4--7 High Data Mask Port-D
#define		NIXE_LDATA_PDMASK	0b11110101	// PD 1,3 Low Data Mask Port-D
#define		NIXE_LDATA_PBMASK	0b11110011	// PB 0,1 Low Data Mask Port-B
#define		NIXE_SELECT_NON		0b00001001	// PC0 -- 3 = 9
#define		NIXE_SELECT_CLR		0b11111000	// PC0 -- 2 Clear
#define		NIXE_SELECT_DIS		0b00001000	// PC3 = H	(PortC@ OR
#define		NIXE_HNUMBER_OFF	0b11110000	// PD4--7:'H'
#define		NIXE_HNUMBER_MASK	0b00001111	// PD4--7:'L'ɂ鎞
#define		NIXE_LNUMBER_PDOFF	0b00001010	// PD1,3:'H'
#define		NIXE_LNUMBER_PDMASK	0b11110101	// PD1,3:'L'ɂ鎞
#define		NIXE_LNUMBER_PBOFF	0b00000011	// PB0,1:'H'
#define		NIXE_LNUMBER_PBMASK	0b11111100	// PB0,1:'L'ɂ鎞

//******************************
//  Nixe\@
// *****************************
void	init_nixe(void)
{
	unsigned char	uc;

	PORTC |= NIXE_SELECT_DIS;					// IȂ
	PORTC &= NIXE_SELECT_CLR;					// IO


	PORTD &= NIXE_HDATA_MASK;					// ʐ}XN
	PORTD |= NIXE_HNUMBER_OFF;					// ʐȂ

	PORTD &= NIXE_LDATA_PDMASK;					// ʐ}XN Port-D
	PORTD |= NIXE_LNUMBER_PDOFF;				// ʐȂ Port-D
	PORTB &= NIXE_LDATA_PBMASK;					// ʐ}XN Port-B
	PORTB |= NIXE_LNUMBER_PBOFF;				// ʐȂ Port-B

	DDRD |= ((1 << DDD1) | (1 << DDD3) | (1 << DDD4) | (1 << DDD5) | (1 << DDD6) | (1 << DDD7));	// Port-D Bit1,34567 : Output
	DDRC |= ((1 << DDC0) | (1 << DDC1) | (1 << DDC2) | (1 << DDC3));	// Port-C Bit0123 : Output
	DDRB |= ((1 << DDB0) | (1 << DDB1));		// Port-B Bit01 : Output

// \AR f[^
	for(uc = 0;uc <= KETA_SEL_MAX; uc++){
		nixie_hdata[uc] = NIXE_HNUMBER_OFF;		// NA
		nixie_lpddata[uc] = NIXE_LNUMBER_PDOFF;	// NA
		nixie_lpbdata[uc] = NIXE_LNUMBER_PBOFF;	// NA
	}

	nixie_select[0] = 0b00000111;		// ŏʁ@N̍ŏʁ@̉
	nixie_select[1] = 0b00000110;		// Qʁ@N̂QԖځ@̏㌅
	nixie_select[2] = 0b00000101;		// Rʁ@N̂RԖځ@̉
	nixie_select[3] = 0b00000100;		// Sʁ@N̍ŉʁ@̏㌅
	nixie_select[4] = 0b00000011;		// Tʁ@̏㌅@@̉
	nixie_select[5] = 0b00000010;		// Uʁ@̉@@b̏㌅
	nixie_select[6] = 0b00000001;		// Vʁ@̏㌅@@b̉
	nixie_select[7] = 0b00000000;		// ŉʁ@j

	nixie_act_num = 0;

	dynamic_nixie = 0;
}
//******************************
// jLV[Ǖ\
// sQ̊荞݂ŌĂ΂
//  d͖TO`Ȃ邪A邭Ȃ
//  for Fourteen IN-17 Clock
//******************************
void	proc_dynamic_nixie(void)
{
	static	unsigned char	path=0;

	if(dynamic_nixie == 1){
		if(path == path_limit){

			PORTC |= NIXE_SELECT_DIS;						// IȂ
			PORTC &= NIXE_SELECT_CLR;						// IO

			PORTD |= NIXE_HNUMBER_OFF;						// ʐȂ
			PORTD |= NIXE_LNUMBER_PDOFF;					// ʐȂ Port-D
			PORTB |= NIXE_LNUMBER_PBOFF;					// ʐȂ Port-B
			if(nixie_act_num <= (KETA_SEL_MAX - 1)){		// ijLV[ǁj
				PORTD &= NIXE_HNUMBER_MASK;					// ʐ}XN
				PORTD &= NIXE_LNUMBER_PDMASK;				// ʐ}XN Port-D
				PORTB &= NIXE_LNUMBER_PBMASK;				// ʐ}XN Port-B
				PORTD |= nixie_hdata[nixie_act_num];		// ʐ
				PORTD |= nixie_lpddata[nixie_act_num];		// ʐiocj
				PORTB |= nixie_lpbdata[nixie_act_num];		// ʐioaj
				PORTC |= nixie_select[nixie_act_num];		// I
				PORTC &= ~NIXE_SELECT_DIS;					// IL

			}else if(nixie_act_num == KETA_SEL_MAX){		// jilIǁj
				PORTD &= NIXE_HNUMBER_MASK;					// ʐ}XN
				PORTD &= NIXE_LNUMBER_PDMASK;				// ʐ}XN Port-D
				PORTB &= NIXE_LNUMBER_PBMASK;				// ʐ}XN Port-B
				PORTD |= nixie_hdata[nixie_act_num];		// ʐ
				PORTD |= nixie_lpddata[nixie_act_num];		// ʐiocj
				PORTB |= nixie_lpbdata[nixie_act_num];		// ʐioaj

				PORTC |= nixie_select[nixie_act_num];		// I
				PORTC &= ~NIXE_SELECT_DIS;					// IL

			}

			if(KETA_SEL_MAX <= nixie_act_num){
				nixie_act_num = 0;
			}else{
				nixie_act_num++;
			}
		}else if(path == 0){
			PORTC |= NIXE_SELECT_DIS;						// IȂ
			PORTC &= NIXE_SELECT_CLR;						// IO

			PORTD |= NIXE_HNUMBER_OFF;						// ʐȂ
			PORTD |= NIXE_LNUMBER_PDOFF;					// ʐȂ Port-D
			PORTB |= NIXE_LNUMBER_PBOFF;					// ʐȂ Port-B
		}

		path++;
		if(PATH_MAX < path){
			path = 0;
		}

	}
}

//******************************
// Dynamic Nixie display Active/Non active
//  on : 1= Active, other=Non Active
// *****************************
void	dynamic_nixie_active(unsigned char on)
{
	dynamic_nixie = on;
}

//******************************
// Nixie \i_Ci~bN_j
//  k : ʒuiO`PSAOFŏʁEEEPSFŉʁj
//  n : O`XAPTiPT͋󔒁j
//@@@ocR@oaP@ocP@oaO
//@@@k@@@k@@@k@@@k@@||@O
//@@@k@@@k@@@k@@@g@@||@P
// *****************************
void	disp_dynamic_nixie_number(unsigned char k, unsigned char n)
{
	if(KETA_SEL_MAX <= k/2){					// IlُȎ
		k = 0;									// Iɍŏʂɂ
	}
	if(k < (KETA_MAX/2)){
		dynamic_nixie_active(0);				// _Ci~bN\~
		nixie_hdata[k] = ((n << 4) & 0xf0);
		dynamic_nixie_active(1);				// _Ci~bN\ĊJ
	}else{
		dynamic_nixie_active(0);				// _Ci~bN\~
		nixie_lpbdata[k-(KETA_MAX/2)] = 0;
		nixie_lpddata[k-(KETA_MAX/2)] = 0;
		nixie_lpbdata[k-(KETA_MAX/2)] |= (n & 0b00000001);
		nixie_lpddata[k-(KETA_MAX/2)] |= (n & 0b00001010);
		if((n & 0b00000100) !=0 ){
			nixie_lpbdata[k-(KETA_MAX/2)] |= 0b00000010;
		}
		dynamic_nixie_active(1);				// _Ci~bN\ĊJ
	}
}
//******************************
// jilIj\i_Ci~bN_j
//  n : O`UAPTiPT͋󔒁j
// *****************************
void	disp_dynamic_day_of_week(unsigned char n)
{
	dynamic_nixie_active(0);				// _Ci~bN\~

	nixie_hdata[KETA_SEL_MAX] = ((n << 4) & 0xf0);

	nixie_lpbdata[KETA_SEL_MAX] = 0;
	nixie_lpddata[KETA_SEL_MAX] = 0;
	nixie_lpbdata[KETA_SEL_MAX] |= (n & 0b00000001);
	nixie_lpddata[KETA_SEL_MAX] |= (n & 0b00001010);
	if((n & 0b00000100) !=0 ){
		nixie_lpbdata[KETA_SEL_MAX] |= 0b00000010;
	}
	dynamic_nixie_active(1);				// _Ci~bN\ĊJ

}

//******************************
// lI\i_Ci~bN_j
//  n : O`QAPTiPT͋󔒁j΂̏
//  n : R`UAPTiPT͋󔒁j؋y̏
//   hdata ɓA ldata ɓ
// *****************************
void	disp_dynamic_tow_neon(unsigned char nh, unsigned char nl)
{
	nixie_hdata[KETA_MAX/2] = ((nh << 4) & 0xf0);

	dynamic_nixie_active(0);				// _Ci~bN\~
	nixie_lpbdata[KETA_SEL_MAX] = 0;
	nixie_lpddata[KETA_SEL_MAX] = 0;
	nixie_lpbdata[KETA_SEL_MAX] |= (nl & 0b00000001);
	nixie_lpddata[KETA_SEL_MAX] |= (nl & 0b00001010);
	if((nl & 0b00000100) !=0 ){
		nixie_lpbdata[KETA_SEL_MAX] |= 0b00000010;
	}
	dynamic_nixie_active(1);				// _Ci~bN\ĊJ

}

//******************************
// Nixie \SARi_Ci~bN_j
// *****************************
void	disp_dynamic_nixie_clear(void)
{
	unsigned char uc;

	for(uc=0;uc < KETA_MAX; uc++){
		disp_dynamic_nixie_number(uc, 15);				//   
	}
	disp_dynamic_day_of_week(15);						// jilIjilPTɂj
}

//******************************
// Nixie \iX^eBbNN_j
//  k : ʒuiO`PTAOFŏʁEEEPTFŉʁj
//  n : O`XAPTiPT͋󔒁j
//   _Ci~bN\͍sĂȂԂɌ
// *****************************
void	disp_static_nixie_number(unsigned char k, unsigned char n)
{
	PORTC |= NIXE_SELECT_DIS;					// IȂ
	PORTC &= NIXE_SELECT_CLR;					// IO

	PORTD |= NIXE_HNUMBER_OFF;					// ʐȂ
	PORTD |= NIXE_LNUMBER_PDOFF;				// ʐȂ Port-D
	PORTB |= NIXE_LNUMBER_PBOFF;				// ʐȂ Port-B

	if(KETA_MAX <= k){							// IlُȎ
		k = 0;									// Iɍŏʂɂ
	}

	if(k < KETA_MAX/2){							// W̎
		PORTD &= NIXE_HNUMBER_MASK;				// }XN
		PORTD |= ((n << 4) & 0xf0);				// 
	}else{
		k -= KETA_MAX/2;
		PORTD &= NIXE_LNUMBER_PDMASK;			// ʐ}XN Port-D
		PORTB &= NIXE_LNUMBER_PBMASK;			// ʐ}XN Port-B
		PORTB |= (n & 0b00000001);
		PORTD |= (n & 0b00001010);
		if((n & 0b00000100) !=0 ){
			PORTB |= 0b00000010;
		}
	}

	PORTC |= nixie_select[k];					// I
	PORTC &= ~NIXE_SELECT_DIS;					// IL


}
//******************************
// j(lIj\iX^eBbNN_j
//  n : O`UAPTiPT͋󔒁j
//   _Ci~bN\͍sĂȂԂɌ
// *****************************
void	disp_static_day_of_week(unsigned char n)
{
	PORTC |= NIXE_SELECT_DIS;				// IȂ
	PORTC &= NIXE_SELECT_CLR;				// IO

	PORTD |= NIXE_HNUMBER_OFF;				// ʐȂ
	PORTD |= NIXE_LNUMBER_PDOFF;			// ʐȂ Port-D
	PORTB |= NIXE_LNUMBER_PBOFF;			// ʐȂ Port-B

	PORTD &= NIXE_HNUMBER_MASK;				// }XN
	PORTD |= ((n << 4) & 0xf0);				// 

	PORTD &= NIXE_LNUMBER_PDMASK;			// ʐ}XN Port-D
	PORTB &= NIXE_LNUMBER_PBMASK;			// ʐ}XN Port-B
	PORTB |= (n & 0b00000001);
	PORTD |= (n & 0b00001010);
	if((n & 0b00000100) !=0 ){
		PORTB |= 0b00000010;
	}

	PORTC |= nixie_select[7];				// I
	PORTC &= ~NIXE_SELECT_DIS;				// IL

}

