//*****************************************
// AT mega328P-PA(32pin TDFP) fourteen IN-172 clock Program
// CPU Clock:8MHz
//   iq[Yf[^@UWlgɂj
// File Name:set_rtc_14keta.c
//
//  C:\WinAVR-20100110\doc\avr-libc\avr-libc-user-manual.pdf ɊeCN[ht@C̐
//
//  2017/09/13 New TAB4 Taishi
//  2017/12/13 Ver 2.00 Taishi
//  2018/10/25 Modify for Fifteen IN-17 Clock Taishi
//  2019/12/30 Modify for fourteen IN-172 Clock Taishi
//*****************************************

#include	<avr/interrupt.h>
#include	<avr/io.h>

#include	"fourteen_in172_clock.h"
#include	"timer.h"
#include	"port_bit.h"
#include	"rtc_ds3234.h"
#include	"display.h"
#include	"nixie.h"
#include	"infrared.h"
#include	"set_rtc.h"
#include	"set_rtc_14keta.h"


//*****************************************
// N킹
// ߂l@OFɂqsbɃANZXł
// @@@@PFɂqsbɃANZXłȂ
// @OFԑ얳
//*****************************************
static	unsigned char	proc_set_year_14keta(void)
{
	unsigned char	blk_stat=0;
	unsigned char	ye;
	unsigned short	us;
	unsigned char	r=0;
	unsigned char	ucinf;
	unsigned char	wday;

	ye = gRTC_year;
	disp_nixie_tow(0,0x20);							// N ʂQ\
	disp_nixie_tow(2,ye);							// N ʂQ\

	tim_10ms_blink = 0;								// _
	while(1){
		us = get_action_sw();						// XCb`Ԃ
		us &= SW_MASK;								// XCb`ɂ
		ucinf = get_infrared_data();				// ԊORfqf[^
		if(us == 0){								// XCb`ĂȂ
			us = trans_if_to_sw(ucinf);				// ԊORf[^XCb`f[^ɕϊ
		}

		if(tim_10ms_blink == 0){					// _Ń^C~O̎
			tim_10ms_blink = 50;
			if((blk_stat==0)&&((us & SW2_ON) == 0)){	// ĂȂ ł̎(select switch)
				blk_stat = 1;
				disp_nixie_tow(2,0xff);				// uN \
			}else{
				blk_stat = 0;
				disp_nixie_tow(2,ye);				// N \
			}
		}

		if(us != 0){								// ANVL鎞
			proc_no_key_timeup(1);					// L[͂L
			if(((us & SW2_ON_CONTINUE) != 0)||((us & SW2_ON_NOW) != 0)){	// ꂽA͉ꑱ(select switch)
				ye++;
				if(9 < (ye & 0x0f)){				// X𒴂
					ye &= 0xf0;
					ye += 0x10;
				}
				if(0x99 < ye){
					ye = 0;
				}
			}else if(((us & SW1_OFF_LONG) != 0)||((us & SW1_OFF_SHORT) != 0)){	// ZAAꎞ(set switch)
				disp_nixie_tow(2,ye);				// N ʂQ\
				if(gRTC_year == ye){				// lύXĂȂ
					r = 0;
				}else{
					gRTC_year = ye;
					wday = subZeller((2000+((gRTC_year >> 4)*10)+(gRTC_year & 0x0f)), (((gRTC_mon >> 4)*10)+(gRTC_mon & 0x0f)), (((gRTC_day >> 4)*10)+(gRTC_day & 0x0f)) );	// cF[̌
					wday++;
					gRTC_wday = wday;				// qsb j̃f[^ (BCD 1--7)
					disp_dynamic_day_of_week(gRTC_wday-1);	// j \
					rtc_write();					// RTC 
				}
				break;
			}
		}

		if (proc_no_key_timeup(0) == 0xff){			// ԃL[͂
			r = 0xff;
			break;
		}
	}

	return(r);
}
//*****************************************
// 킹
// ߂l@OFɂqsbɃANZXł
// @@@@PFɂqsbɃANZXłȂ
// @OFԑ얳
//*****************************************
static	unsigned char	proc_set_month_14keta(void)
{
	unsigned char	blk_stat=0;
	unsigned char	mo;
	unsigned short	us;
	unsigned char	r=0;
	unsigned char	ucinf;
	unsigned char	wday;

	mo = gRTC_mon;
	disp_nixie_tow(4,mo);							//  ʂQ\

	tim_10ms_blink = 0;								// _
	while(1){
		us = get_action_sw();						// XCb`Ԃ
		us &= SW_MASK;								// XCb`ɂ
		ucinf = get_infrared_data();				// ԊORfqf[^
		if(us == 0){								// XCb`ĂȂ
			us = trans_if_to_sw(ucinf);				// ԊORf[^XCb`f[^ɕϊ
		}

		if(tim_10ms_blink == 0){					// _Ń^C~O̎
			tim_10ms_blink = 50;
			if((blk_stat==0)&&((us & SW2_ON) == 0)){	// ꂢȂ ł̎(select switch)
				blk_stat = 1;
				disp_nixie_tow(4,0xff);				// uN \
			}else{
				blk_stat = 0;
				disp_nixie_tow(4,mo);				//  \
			}
		}

		if(us != 0){								// EANVL鎞
			proc_no_key_timeup(1);					// L[͂L
			if(((us & SW2_ON_CONTINUE) != 0)||((us & SW2_ON_NOW) != 0)){	// ꂽA͉ꑱ(select switch)
				mo++;
				if(9 < (mo & 0x0f)){				// X𒴂
					mo &= 0xf0;
					mo += 0x10;
				}
				if(0x12 < mo){
					mo = 1;
				}
			}else if(((us & SW1_OFF_LONG) != 0)||((us & SW1_OFF_SHORT) != 0)){	// ZAAꎞ(set switch)
				disp_nixie_tow(4,mo);				//  ʂQ\
				if(gRTC_mon == mo){					// lύXĂȂ
					r = 0;
				}else{
					gRTC_mon = mo;
					wday = subZeller((2000+((gRTC_year >> 4)*10)+(gRTC_year & 0x0f)), (((gRTC_mon >> 4)*10)+(gRTC_mon & 0x0f)), (((gRTC_day >> 4)*10)+(gRTC_day & 0x0f)) );	// cF[̌
					wday++;
					gRTC_wday = wday;				// qsb j̃f[^ (BCD 1--7)
					disp_dynamic_day_of_week(gRTC_wday-1);	// j \
					rtc_write();					// RTC 
				}
				break;
			}
		}

		if (proc_no_key_timeup(0) == 0xff){			// ԃL[͂
			r = 0xff;
			break;
		}
	}

	return(r);
}
//*****************************************
// 킹
// ߂l@OFɂqsbɃANZXł
// @@@@PFɂqsbɃANZXłȂ
// @OFԑ얳
//*****************************************
static	unsigned char	proc_set_day_14keta(void)
{
	unsigned char	blk_stat=0;
	unsigned char	da;
	unsigned short	us;
	unsigned char	r=0;
	unsigned char	uru=0;
	unsigned char	syo=0;
	unsigned char	ucinf;
	unsigned char	wday;

	if(((((gRTC_year/16)*10)+(gRTC_year/16))/4) == 0){	// 邤N
		uru=1;
	}
	if((gRTC_mon == 0x04)||(gRTC_mon == 0x06)||(gRTC_mon == 0x09)||(gRTC_mon == 0x11)){	// ̌
		syo=1;
	}
	da = gRTC_day;
	disp_nixie_tow(6,da);							// \

	tim_10ms_blink = 0;								// _
	while(1){
		us = get_action_sw();						// XCb`Ԃ
		us &= SW_MASK;								// XCb`ɂ
		ucinf = get_infrared_data();				// ԊORfqf[^
		if(us == 0){								// XCb`ĂȂ
			us = trans_if_to_sw(ucinf);				// ԊORf[^XCb`f[^ɕϊ
		}

		if(tim_10ms_blink == 0){					// _Ń^C~O̎
			tim_10ms_blink = 50;
			if((blk_stat==0)&&((us & SW2_ON) == 0)){	// ꂢȂ ł̎(select switch)
				blk_stat = 1;
				disp_nixie_tow(6,0xff);				// uN \
			}else{
				blk_stat = 0;
				disp_nixie_tow(6,da);				//  \
			}
		}

		if(us != 0){								// ANVL鎞
			proc_no_key_timeup(1);					// L[͂L
			if(((us & SW2_ON_CONTINUE) != 0)||((us & SW2_ON_NOW) != 0)){	// ꂽA͉ꑱ(select switch)
				da++;
				if(9 < (da & 0x0f)){				// X𒴂
					da &= 0xf0;
					da += 0x10;
				}
				if(syo == 1){						// ̌
					if(0x30 < da){
						da = 1;
					}
				}else if(gRTC_mon == 0x02){
					if(uru == 1){					// Q 邤N
						if(0x29 < da){
							da = 1;
						}
					}else{							// Q N
						if(0x28 < da){
							da = 1;
						}
					}
				}else{								// ̌
					if(0x31 < da){
						da = 1;
					}
				}
			}else if(((us & SW1_OFF_LONG) != 0)||((us & SW1_OFF_SHORT) != 0)){	// ZAAꎞ(set switch)
				disp_nixie_tow(6,da);				// \
				if(gRTC_day == da){					// lύXĂȂ
					r = 0;
				}else{
					gRTC_day = da;
					wday = subZeller((2000+((gRTC_year >> 4)*10)+(gRTC_year & 0x0f)), (((gRTC_mon >> 4)*10)+(gRTC_mon & 0x0f)), (((gRTC_day >> 4)*10)+(gRTC_day & 0x0f)) );	// cF[̌
					wday++;
					gRTC_wday = wday;				// qsb j̃f[^ (BCD 1--7)
					disp_dynamic_day_of_week(gRTC_wday-1);	// j \
					rtc_write();					// RTC 
				}
				break;								// I
			}
		}

		if (proc_no_key_timeup(0) == 0xff){			// ԃL[͂
			r = 0xff;
			break;
		}
	}

	return(r);
}
//*****************************************
// 킹
// ߂l@OFɂqsbɃANZXł
// @@@@PFɂqsbɃANZXłȂ
// @OFԑ얳
//*****************************************
static	unsigned char	proc_set_hour_14keta(void)
{
	unsigned char	blk_stat=0;
	unsigned char	ho;
	unsigned short	us;
	unsigned char	r=0;
	unsigned char	ucinf;

	ho = gRTC_hou;
	disp_nixie_tow(8,ho);							// \

	tim_10ms_blink = 0;								// _
	while(1){
		us = get_action_sw();						// XCb`Ԃ
		us &= SW_MASK;								// XCb`ɂ
		ucinf = get_infrared_data();				// ԊORfqf[^
		if(us == 0){								// XCb`ĂȂ
			us = trans_if_to_sw(ucinf);				// ԊORf[^XCb`f[^ɕϊ
		}

		if(tim_10ms_blink == 0){					// _Ń^C~O̎
			tim_10ms_blink = 50;
			if((blk_stat==0)&&((us & SW2_ON) == 0)){	// ꂢȂ ł̎(select switch)
				blk_stat = 1;
				disp_nixie_tow(8,0xff);				// uN \
			}else{
				blk_stat = 0;
				disp_nixie_tow(8,ho);				// \
			}
		}

		if(us != 0){								// ANVL鎞
			proc_no_key_timeup(1);					// L[͂L
			if(((us & SW2_ON_CONTINUE) != 0)||((us & SW2_ON_NOW) != 0)){	// ꂽA͉ꑱ(select switch)
				ho++;
				if(9 < (ho & 0x0f)){				// X𒴂
					ho &= 0xf0;
					ho += 0x10;
				}
				if(0x23 < ho){
					ho = 0;
				}
			}else if(((us & SW1_OFF_LONG) != 0)||((us & SW1_OFF_SHORT) != 0)){	// ZAAꎞ(set switch)
				disp_nixie_tow(8,ho);				// \
				if(gRTC_hou == ho){					// lύXĂȂ
					r = 0;
				}else{
					gRTC_hou = ho;
					rtc_write();					// RTC 
				}
				break;
			}
		}

		if (proc_no_key_timeup(0) == 0xff){			// ԃL[͂
			r = 0xff;
			break;
		}
	}

	return(r);
}
//*****************************************
// 킹
// ߂l@OFɂqsbɃANZXł
// @@@@PFɂqsbɃANZXłȂ
// @OFԑ얳
//*****************************************
static	unsigned char	proc_set_minute_14keta(void)
{
	unsigned char	blk_stat=0;
	unsigned char	mi;
	unsigned short	us;
	unsigned char	r=0;
	unsigned char	ucinf;

	mi = gRTC_min;
	disp_nixie_tow(10,mi);							// \

	tim_10ms_blink = 0;								// _
	while(1){
		us = get_action_sw();						// XCb`Ԃ
		us &= SW_MASK;								// XCb`ɂ
		ucinf = get_infrared_data();				// ԊORfqf[^
		if(us == 0){								// XCb`ĂȂ
			us = trans_if_to_sw(ucinf);				// ԊORf[^XCb`f[^ɕϊ
		}

		if(tim_10ms_blink == 0){					// _Ń^C~O̎
			tim_10ms_blink = 50;
			if((blk_stat==0)&&((us & SW2_ON) == 0)){	// ꂢȂ ł̎(select switch)
				blk_stat = 1;
				disp_nixie_tow(10,0xff);			// uN\
			}else{
				blk_stat = 0;
				disp_nixie_tow(10,mi);				// \
			}
		}

		if(us != 0){								// ANVL鎞
			proc_no_key_timeup(1);					// L[͂L
			if(((us & SW2_ON_CONTINUE) != 0)||((us & SW2_ON_NOW) != 0)){	// ꂽA͉ꑱ(select switch)
				mi++;
				if(9 < (mi & 0x0f)){				// X𒴂
					mi &= 0xf0;
					mi += 0x10;
				}
				if(0x59 < mi){
					mi = 0;
				}
			}else if(((us & SW1_OFF_LONG) != 0)||((us & SW1_OFF_SHORT) != 0)){	// ZAAꎞ(set switch)
				disp_nixie_tow(10,mi);				// \
				if(gRTC_min == mi){					// lύXĂȂ
					r = 0;
				}else{
					gRTC_min = mi;
					rtc_write();					// RTC 
				}
				break;
			}
		}

		if (proc_no_key_timeup(0) == 0xff){			// ԃL[͂
			r = 0xff;
			break;
		}
	}

	return(r);
}
//*****************************************
// b킹
// ߂l@OFɂqsbɃANZXł
// @@@@PFɂqsbɃANZXłȂ
// @OFԑ얳
//*****************************************
static	unsigned char	proc_set_sec_14keta(void)
{
	unsigned char	blk_stat=0;
	unsigned char	se;
	unsigned short	us;
	unsigned char	r=0;
	unsigned char	ucinf;

	se = gRTC_sec;
	disp_nixie_tow(12,se);							// b \

	tim_10ms_blink = 0;								// _
	while(1){
		us = get_action_sw();						// XCb`Ԃ
		us &= SW_MASK;								// XCb`ɂ
		ucinf = get_infrared_data();				// ԊORfqf[^
		if(us == 0){								// XCb`ĂȂ
			us = trans_if_to_sw(ucinf);				// ԊORf[^XCb`f[^ɕϊ
		}

		if(tim_10ms_blink == 0){					// _Ń^C~O̎
			tim_10ms_blink = 50;
			if((blk_stat==0)&&((us & SW2_ON) == 0)){	// ꂢȂ ł̎(select switch)
				blk_stat = 1;
				disp_nixie_tow(12,0xff);			// uN Q\
			}else{
				blk_stat = 0;
				disp_nixie_tow(12,se);				// b \
			}
		}

		if(us != 0){								// ANVL鎞
			proc_no_key_timeup(1);					// L[͂L
			if(((us & SW2_ON_CONTINUE) != 0)||((us & SW2_ON_NOW) != 0)){	// ꂽA͉ꑱ(select switch)
				se++;
				if(9 < (se & 0x0f)){				// X𒴂
					se &= 0xf0;
					se += 0x10;
				}
				if(0x59 < se){
					se = 0;
				}
			}else if(((us & SW1_OFF_LONG) != 0)||((us & SW1_OFF_SHORT) != 0)){	// ZAAꎞ(set switch)
				disp_nixie_tow(12,se);				// b \
				if(gRTC_min == se){					// lύXĂȂ
					r = 0;
				}else{
					gRTC_sec = se;
					rtc_write();					// RTC 
				}
				break;
			}
		}

		if (proc_no_key_timeup(0) == 0xff){			// ԃL[͂
			r = 0xff;
			break;
		}
	}

	return(r);
}
//*****************************************
// PSv킹
// ߂l@OFɂqsbɃANZXł
// @@@@PFɂqsbɃANZXłȂ
// @OFԑ얳
//*****************************************
unsigned char	proc_set_rtc_14keta(void)
{
	unsigned char	r;

	disp_dynamic_day_of_week(15);					// jilIjilPTɂj
	r = proc_set_year_14keta();						// N킹
	if(r == 0){
		r = proc_set_month_14keta();				// 킹
		if(r == 0){
			r = proc_set_day_14keta();				// 킹
			if(r == 0){
				r = proc_set_hour_14keta();			// 킹
				if(r == 0){
					r = proc_set_minute_14keta();	// 킹
					if(r == 0){
						r = proc_set_sec_14keta();	// b킹
					}
				}
			}
		}
	}
	return(r);
}

